#line 1 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/I2C 40x4 LCD AVR/I2C 40x4 LCD.c"
#line 22 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/I2C 40x4 LCD AVR/I2C 40x4 LCD.c"
const char txt1[] = "I have to connect 40x4 lcd to my project";
const char txt2[] = "The lcd have 2 Enable pins ,";
const char txt3[] = "EN1 for rows 1&2 and EN2 for rows 3&4";
const char txt4[] = "How can I connect it to my Board? ";

char txt[42];

const char character[] = {0,10,21,17,10,4,0,0};


char hours, minutes, seconds, day, week, month, year;

void TWI_LCD_Send_Nibble_1(char rs, char out_char) {
 TWI_Start();
 TWI_Write( 0x4E );
 TWI_Write((out_char & 0xF0) | rs | 0x02 | 0x08 | 0x04);
 Delay_us(200);
 TWI_Write((out_char & 0xF0) | rs | 0x00 | 0x08 | 0x04);
 Delay_us(200);
 TWI_Write((out_char & 0xF0) | rs | 0x02 | 0x08 | 0x04);
 TWI_Stop();
}

void TWI_LCD_Send_Nibble_2(char rs, char out_char) {
 TWI_Start();
 TWI_Write( 0x4E );
 TWI_Write((out_char & 0xF0) | rs | 0x04 | 0x08 | 0x02);
 Delay_us(200);
 TWI_Write((out_char & 0xF0) | rs | 0x00 | 0x08 | 0x02);
 Delay_us(200);
 TWI_Write((out_char & 0xF0) | rs | 0x04 | 0x08 | 0x02);
 TWI_Stop();
}

void TWI_LCD_Send_Nibbles_1(char rs, char out_char) {

 char hi_n = 0, lo_n = 0;

 hi_n = out_char & 0xF0;
 lo_n = out_char << 4;

 TWI_Start();
 TWI_Write( 0x4E );
 Delay_us(80);
 TWI_Write(hi_n | rs | 0x00 | 0x08 | 0x04);
 Delay_us(20);
 TWI_Write(hi_n | rs | 0x02 | 0x08 | 0x04);
 Delay_us(80);
 TWI_Write(lo_n | rs | 0x00 | 0x08 | 0x04);
 Delay_us(80);
 TWI_Write(lo_n | rs | 0x02 | 0x08 | 0x04);
 TWI_Stop();
}

void TWI_LCD_Send_Nibbles_2(char rs, char out_char) {
 char hi_n = 0, lo_n = 0;

 hi_n = out_char & 0xF0;
 lo_n = out_char << 4;

 TWI_Start();
 TWI_Write( 0x4E );
 Delay_us(80);
 TWI_Write(hi_n | rs | 0x00 | 0x08 | 0x02);
 Delay_us(20);
 TWI_Write(hi_n | rs | 0x04 | 0x08 | 0x02);
 Delay_us(80);
 TWI_Write(lo_n | rs | 0x00 | 0x08 | 0x02);
 Delay_us(80);
 TWI_Write(lo_n | rs | 0x04 | 0x08 | 0x02);
 TWI_Stop();
}

void TWI_LCD_Init() {

 Delay_ms(200);

 TWI_LCD_Send_Nibble_1(0,0x30); Delay_ms(200);
 TWI_LCD_Send_Nibble_1(0,0x30); Delay_ms(80);
 TWI_LCD_Send_Nibble_1(0,0x30); Delay_ms(80);
 TWI_LCD_Send_Nibble_1(0,0x20); Delay_ms(12);
 TWI_LCD_Send_Nibbles_1(0,0x01); Delay_ms(12);
 TWI_LCD_Send_Nibbles_1(0,0x28); Delay_ms(4);Delay_ms(12);
 TWI_LCD_Send_Nibbles_1(0,0x0C); Delay_ms(4);Delay_ms(12);
 TWI_LCD_Send_Nibbles_1(0,0X06); Delay_ms(4);Delay_ms(12);

 TWI_LCD_Send_Nibble_2(0,0x30); Delay_ms(200);
 TWI_LCD_Send_Nibble_2(0,0x30); Delay_ms(80);
 TWI_LCD_Send_Nibble_2(0,0x30); Delay_ms(80);
 TWI_LCD_Send_Nibble_2(0,0x20); Delay_ms(12);
 TWI_LCD_Send_Nibbles_2(0,0x01); Delay_ms(12);
 TWI_LCD_Send_Nibbles_2(0,0x28); Delay_ms(4);Delay_ms(12);
 TWI_LCD_Send_Nibbles_2(0,0x0C); Delay_ms(4);Delay_ms(12);
 TWI_LCD_Send_Nibbles_2(0,0X06); Delay_ms(4);Delay_ms(12);
}

void TWI_LCD_XY_OUT_1(char row, char column) {
 if(row == 1)TWI_LCD_Send_Nibbles_1(0,128 + column);
 if(row == 2)TWI_LCD_Send_Nibbles_1(0,192 + column);
 if(row == 3)TWI_LCD_Send_Nibbles_1(0,148 + column);
 if(row == 4)TWI_LCD_Send_Nibbles_1(0,212 + column);
 Delay_us(50);
}

void TWI_LCD_XY_OUT_2(char row, char column) {
 if(row == 1)TWI_LCD_Send_Nibbles_2(0,128 + column);
 if(row == 2)TWI_LCD_Send_Nibbles_2(0,192 + column);
 if(row == 3)TWI_LCD_Send_Nibbles_2(0,148 + column);
 if(row == 4)TWI_LCD_Send_Nibbles_2(0,212 + column);
 Delay_us(50);
}

void TWI_LCD_Cmd(char out_char) {
 TWI_LCD_Send_Nibbles_1(0,out_char);
 TWI_LCD_Send_Nibbles_2(0,out_char);
}

void TWI_LCD_Chr(char row, char column, char out_char) {
 if((row == 1) || (row == 2)) {
 if ((row == 1) && (column > 20)) {row = 3; column = column - 20;}
 if ((row == 2) && (column > 20)) {row = 4; column = column - 20;}
 TWI_LCD_XY_OUT_1(row,column-1);
 TWI_LCD_Send_Nibbles_1(1,out_char);
 Delay_us(40);
 }
 else {
 if (row == 3) row = 1;
 if (row == 4) row = 2;
 if ((row == 1) && (column > 20)) {row = 3; column = column - 20;}
 if ((row == 2) && (column > 20)) {row = 4; column = column - 20;}
 TWI_LCD_XY_OUT_2(row,column-1);
 TWI_LCD_Send_Nibbles_2(1,out_char);
 Delay_us(40);
 }
}

void TWI_LCD_Chr_Cp(char out_char) {
 TWI_LCD_Send_Nibbles_1(1,out_char);
 TWI_LCD_Send_Nibbles_2(1,out_char);
 Delay_us(40);
}


void TWI_LCD_Out(char row, char col, char *text) {
 while(*text)
 TWI_LCD_Chr(row, col++, *text++);
}

void TWI_LCD_Out_Cp(char *text) {
 while(*text)
 TWI_LCD_Chr_Cp(*text++);
}

void CustomChar(char pos_row, char pos_char) {
 char i;

 TWI_LCD_Cmd(64);
 for (i = 0; i<=7; i++) TWI_LCD_Chr_CP(character[i]);
 TWI_LCD_Cmd( 0x02 );
 TWI_LCD_Chr(pos_row, pos_char, 0);
 Delay_ms(2);
}


char *CopyConst2Ram(char *dest, const char *src) {
 char *d;

 d = dest;
 for(;*dest++ = *src++;);
 return d;
}

void main() {

 DDRC = 0xFF;

 TWI_Init(100000);

 TWI_LCD_Init();
 TWI_LCD_Cmd( 0x0C );
 TWI_LCD_Cmd( 0x01 );

 TWI_LCD_Out(1,1,CopyConst2Ram(txt, txt1));
 TWI_LCD_Out(2,1,CopyConst2Ram(txt, txt2));
 TWI_LCD_Out(3,1,CopyConst2Ram(txt, txt3));
 TWI_LCD_Out(4,1,CopyConst2Ram(txt, txt4));

 while(1) {

 }
}
